
// 
// see http://www.hex705.com/processing-midi-garageband/ 
// created by hex705,  steve daniels, January 2011.
// 

// use 'a','s','d','f' to send note signals to Garage Band
// change your keyboard setting in sys preferences if you want to control repeats and duration
// mouse sends fixed length notes

import rwmidi.*;

MidiOutput output;

// variables for note generation from keystrike
int aChannel,  sChannel,  dChannel,  fChannel;
int aNote,     sNote,     dNote,     fNote;
int aVelocity, sVelocity, dVelocity, fVelocity;
int aSuccess,  sSuccess,  dSuccess,  fSuccess;

void setup() {
  
  size(256,256);
  
  // just like serial ports, you can list the devices if you like 
  /*
  println("output devices");
  println(RWMidi.getOutputDevices());
  println("\ninput devices");
  println(RWMidi.getInputDevices());
  */
  
  // creates a connection to IAC as an output
  output = RWMidi.getOutputDevices()[0].createOutput();  // talks to garageband  
  
}

void draw() {
  // nothing here
}

void mousePressed() {
  
  // send a note 400 mS long 
  int duration = 400;
  
  int channel  = 1;    // GB seems to ignore this, but mehtod needs it
  int note     = 60;   // midi notes are numbered 0 -127 -- not all notes are played by all voices
  int velocity = 127;  // velocity == loudness, range 0-127, 127= max
  
  int success = output.sendNoteOn(channel, note, velocity);  // sendNoteOn returns 0 = fail, 1 = success                                            
  delay(duration);  // note length  -see keys below for better solution
  success =    output.sendNoteOff(channel, note, velocity);  // sendNoteOff returns 0 = fail, 1 = success
                                               
}


void keyPressed(){
  
  if (key == 'a' || key == 'A' ) {
    aChannel = 1;
    aNote = 60;
    aVelocity = 127;
    aSuccess = output.sendNoteOn(aChannel, aNote, aVelocity); // note return a variable of type INT 
  }
  
  if (key == 's' || key == 'S' ) {
    sChannel = 1;
    sNote = 61;
    sVelocity = 127;
    sSuccess = output.sendNoteOn(sChannel, sNote, sVelocity); // note return a variable of type INT
  }
  
  if (key == 'd' || key == 'D' ) {
    dChannel = 1;
    dNote = 62;
    dVelocity = 127;
    dSuccess = output.sendNoteOn(dChannel, dNote, dVelocity); // note return a variable of type INT
    
  }
  
  if (key == 'f' || key == 'F' ) {
    fChannel = 1;
    fNote = 63;
    fVelocity = 127;
    fSuccess = output.sendNoteOn(fChannel, fNote, fVelocity); // note return a variable of type INT
    
  }
  
}

void keyReleased(){
  
  if (key == 'a' || key == 'A' ) {
    
    aSuccess = output.sendNoteOff(aChannel, aNote, aVelocity); // note return a variable of type INT
    
  }
  
  if (key == 's' || key == 'S' ) {
    
    sSuccess = output.sendNoteOff(sChannel, sNote, sVelocity); // note return a variable of type INT
    
  }
  
  if (key == 'd' || key == 'D' ) {
    
    dSuccess = output.sendNoteOff(dChannel, dNote, dVelocity); // note return a variable of type INT
    
  }
  
  if (key == 'f' || key == 'F' ) {
    
    fSuccess = output.sendNoteOff(fChannel, fNote, fVelocity); // note return a variable of type INT
    
  }
  
}
    
    
    
    
